//  (C) Copyright David Abrahams 2000. Permission to copy, use, modify, sell and
//  distribute this software is granted provided this copyright notice appears
//  in all copies. This software is provided "as is" without express or implied
//  warranty, and with no claim as to its suitability for any purpose.
//
//  The author gratefully acknowleges the support of Dragon Systems, Inc., in
//  producing this work.
//
//  This file automatically generated for 5-argument constructors by
//  gen_constructors.py

#ifndef CONSTRUCTORS_DWA051900_H_
# define CONSTRUCTORS_DWA051900_H_

# include "pyconfig.h"
# include "wrap_python.h"
# include "signatures.h"

namespace py {

template <class T> struct Ctor0;
template <class T, class A1> struct Ctor1;
template <class T, class A1, class A2> struct Ctor2;
template <class T, class A1, class A2, class A3> struct Ctor3;
template <class T, class A1, class A2, class A3, class A4> struct Ctor4;
template <class T, class A1, class A2, class A3, class A4, class A5> struct Ctor5;


template <class T>
struct Ctor
{
    virtual ~Ctor() {}
    virtual T* operator()(PyObject* args, PyObject* keywords) = 0;

    static Ctor0<T>* create(Signature0)
        { return new Ctor0<T>; }

    template <class A1>
    static Ctor1<T, A1>* create(Signature1<A1>)
        { return new Ctor1<T, A1>; }

    template <class A1, class A2>
    static Ctor2<T, A1, A2>* create(Signature2<A1, A2>)
        { return new Ctor2<T, A1, A2>; }

    template <class A1, class A2, class A3>
    static Ctor3<T, A1, A2, A3>* create(Signature3<A1, A2, A3>)
        { return new Ctor3<T, A1, A2, A3>; }

    template <class A1, class A2, class A3, class A4>
    static Ctor4<T, A1, A2, A3, A4>* create(Signature4<A1, A2, A3, A4>)
        { return new Ctor4<T, A1, A2, A3, A4>; }

    template <class A1, class A2, class A3, class A4, class A5>
    static Ctor5<T, A1, A2, A3, A4, A5>* create(Signature5<A1, A2, A3, A4, A5>)
        { return new Ctor5<T, A1, A2, A3, A4, A5>; }
};


template <class T>
struct Ctor0 : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
        if (!PyArg_ParseTuple(args, const_cast<char*>("")))
            return 0;
        return new T();
    }
};

template <class T, class A1>
struct Ctor1 : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
        PyObject* a1;
        if (!PyArg_ParseTuple(args, const_cast<char*>("O"), &a1))
            return 0;
        return new T(
            from_python(a1, Type<A1>())
            );
    }
};

template <class T, class A1, class A2>
struct Ctor2 : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
        PyObject* a1;
        PyObject* a2;
        if (!PyArg_ParseTuple(args, const_cast<char*>("OO"), &a1, &a2))
            return 0;
        return new T(
            from_python(a1, Type<A1>()),
            from_python(a2, Type<A2>())
            );
    }
};

template <class T, class A1, class A2, class A3>
struct Ctor3 : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
        PyObject* a1;
        PyObject* a2;
        PyObject* a3;
        if (!PyArg_ParseTuple(args, const_cast<char*>("OOO"), &a1, &a2, &a3))
            return 0;
        return new T(
            from_python(a1, Type<A1>()),
            from_python(a2, Type<A2>()),
            from_python(a3, Type<A3>())
            );
    }
};

template <class T, class A1, class A2, class A3, class A4>
struct Ctor4 : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
        PyObject* a1;
        PyObject* a2;
        PyObject* a3;
        PyObject* a4;
        if (!PyArg_ParseTuple(args, const_cast<char*>("OOOO"), &a1, &a2, &a3, &a4))
            return 0;
        return new T(
            from_python(a1, Type<A1>()),
            from_python(a2, Type<A2>()),
            from_python(a3, Type<A3>()),
            from_python(a4, Type<A4>())
            );
    }
};

template <class T, class A1, class A2, class A3, class A4, class A5>
struct Ctor5 : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
        PyObject* a1;
        PyObject* a2;
        PyObject* a3;
        PyObject* a4;
        PyObject* a5;
        if (!PyArg_ParseTuple(args, const_cast<char*>("OOOOO"), &a1, &a2, &a3, &a4, &a5))
            return 0;
        return new T(
            from_python(a1, Type<A1>()),
            from_python(a2, Type<A2>()),
            from_python(a3, Type<A3>()),
            from_python(a4, Type<A4>()),
            from_python(a5, Type<A5>())
            );
    }
};


} // namespace py

#endif
