from gen_function import *
import string

def gen_constructors(args):
    forward_declaration = 'template <class T%(, class A%n%)> struct Ctor%x;\n'

    create = '''
%{    template <%(class A%n%:, %)>
%}    static Ctor%x<T%(, A%n%)>* create(Signature%x%{<%(A%n%:, %)>%})
        { return new Ctor%x<T%(, A%n%)>; }
'''
    ctor = '''
template <class T%(, class A%n%)>
struct Ctor%x : Ctor<T>
{
    T* operator()(PyObject* args, PyObject* /*keywords*/)
    {
%(        PyObject* a%n;
%)        if (!PyArg_ParseTuple(args, const_cast<char*>("%(O%)")%(, &a%n%)))
            return 0;
        return new T(%{%(
            from_python(a%n, Type<A%n>())%:,%)
            %});
    }
};
'''
    return (
'''//  (C) Copyright David Abrahams 2000. Permission to copy, use, modify, sell and
//  distribute this software is granted provided this copyright notice appears
//  in all copies. This software is provided "as is" without express or implied
//  warranty, and with no claim as to its suitability for any purpose.
//
//  The author gratefully acknowleges the support of Dragon Systems, Inc., in
//  producing this work.
//
//  This file automatically generated for %d-argument constructors by
//  gen_constructors.py

#ifndef CONSTRUCTORS_DWA051900_H_
# define CONSTRUCTORS_DWA051900_H_

# include "pyconfig.h"
# include "wrap_python.h"
# include "signatures.h"

namespace py {

''' % args
        + gen_functions(forward_declaration, args) +
'''

template <class T>
struct Ctor
{
    virtual ~Ctor() {}
    virtual T* operator()(PyObject* args, PyObject* keywords) = 0;
'''
        + gen_functions(create, args)
        +
'''};

'''
        + gen_functions(ctor, args)
        +
'''

} // namespace py

#endif
''')

if __name__ == '__main__':
    import sys

    if len(sys.argv) == 1:
        args = 5
    else:
        args = int(sys.argv[1])

    print gen_constructors(args)


