//  (C) Copyright David Abrahams 2000. Permission to copy, use, modify, sell and
//  distribute this software is granted provided this copyright notice appears
//  in all copies. This software is provided "as is" without express or implied
//  warranty, and with no claim as to its suitability for any purpose.
//
//  The author gratefully acknowleges the support of Dragon Systems, Inc., in
//  producing this work.

#include "py.h"
#include "module.h"
#include "subclass.h"
#include <cassert>
#include "none.h"

namespace extclass_demo { void init_module(py::Module&); }

void init_module()
{
    py::Module cpp("cpp");
    extclass_demo::init_module(cpp);

    // Just for giggles, add a raw metaclass.
    cpp.add("MetaClass", new py::MetaClass<py::Instance>);
}


extern "C" __declspec(dllexport) void initcpp();

extern "C" __declspec(dllexport) void initcpp()
{
    try {
        init_module();
    }
    catch(...) {
        py::handle_exception();
    } // Need a way to report other errors here
}

#if defined(_WIN32)
#include <windows.h>
extern "C" BOOL WINAPI DllMain ( HINSTANCE hInst, DWORD wDataSeg, LPVOID lpvReserved );

BOOL WINAPI DllMain(
    HINSTANCE,  //hDllInst
    DWORD fdwReason,
    LPVOID  // lpvReserved
    )
{
    return 1;
    (void)fdwReason; // warning suppression.
}
#endif
